############################################################################
#                                                                          #
#  Copyright (c) 2001, 2014 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXSudo::loadHandlersArray{package NXSudo;no warnings;(
$MessagesFromSudoCommand{$GLOBAL::MSG_ASK_USER_CERT}=
"\x68\x61\x6e\x64\x6c\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65"
);($MessagesFromSudoCommand{$GLOBAL::MSG_ASK_USER_PUBLIC_KEY}=
"\x68\x61\x6e\x64\x6c\x65\x41\x73\x6b\x55\x73\x65\x72\x53\x65\x74\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x4f\x6e\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65"
);($MessagesFromSudoCommand{$GLOBAL::MSG_ASK_LOGIN}=
"\x68\x61\x6e\x64\x6c\x65\x41\x73\x6b\x55\x73\x65\x72\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x53\x75\x64\x6f\x55\x73\x65\x72\x6e\x61\x6d\x65"
);($MessagesFromSudoCommand{$GLOBAL::MSG_ASK_PASSWORD}=
"\x68\x61\x6e\x64\x6c\x65\x41\x73\x6b\x55\x73\x65\x72\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x53\x75\x64\x6f\x50\x61\x73\x73\x77\x6f\x72\x64"
);($MessagesFromSudoCommand{$GLOBAL::MSG_SUDO_VERIFICATION}=
"\x68\x61\x6e\x64\x6c\x65\x41\x73\x6b\x55\x73\x65\x72\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x53\x75\x64\x6f\x50\x72\x6f\x6d\x70\x74"
);($MessagesFromSudoCommand{$GLOBAL::MSG_ASK_USER_WRONG_CERT}=
"\x68\x61\x6e\x64\x6c\x65\x57\x72\x6f\x6e\x67\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65"
);}sub NXSudo::handleCertificationOfRemoteNode{package NXSudo;no warnings;(my $msg
=shift (@_));Logger::debug (((
"\x68\x61\x6e\x64\x6c\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x3a\x20\x61\x72\x72\x69\x76\x65\x20\x77\x69\x74\x68\x20\x5b"
.$msg)."\x5d"));if (($msg=~ /NX> $GLOBAL::MSG_ASK_USER_CERT '(.*)'/ )){
__saveRemoteNodeCertificate ($1);Logger::debug (
"\x68\x61\x6e\x64\x6c\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x3a\x20\x61\x73\x6b\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6e\x66\x69\x72\x6d\x20\x66\x69\x6e\x67\x65\x72\x70\x72\x69\x6e\x74"
);(my $answer=NXMsg::send_request (
"\x63\x6f\x6e\x66\x69\x72\x6d\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65",
"\x4e\x58\x53\x75\x64\x6f",undef,__getRemoteNodeCertificate ()));Logger::debug (
((
"\x68\x61\x6e\x64\x6c\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x3a\x20\x67\x65\x74\x20\x66\x72\x6f\x6d\x20\x6e\x78\x70\x6c\x61\x79\x65\x72\x20"
.$answer)."\x2c\x20\x70\x61\x73\x73\x20\x74\x6f\x20\x6e\x6f\x64\x65"));
NXNodeExec::sendToNode ($answer);}elsif (($msg=~ /NX> $GLOBAL::MSG_ASK_USER_CERT / )
){Logger::debug (((
"\x68\x61\x6e\x64\x6c\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x3a\x20\x73\x6b\x69\x70\x20\x6e\x6f\x74\x20\x73\x68\x6f\x77\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x20"));}else{Logger::error (((
"\x53\x6f\x6d\x65\x74\x68\x69\x6e\x67\x20\x67\x6f\x65\x73\x20\x77\x72\x6f\x6e\x67\x20\x77\x69\x74\x68\x20"
.$msg)."\x2e"));}}sub NXSudo::handleWrongCertificationOfRemoteNode{package 
NXSudo;no warnings;(my $msg=shift (@_));Logger::debug (((
"\x68\x61\x6e\x64\x6c\x65\x57\x72\x6f\x6e\x67\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x4f\x66\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x3a\x20\x61\x72\x72\x69\x76\x65\x20\x77\x69\x74\x68\x20\x5b"
.$msg)."\x5d"));if (($msg=~ /NX> $GLOBAL::MSG_ASK_USER_WRONG_CERT Warning, remote host identification has changed./ )
){Logger::debug (
"\x41\x73\x6b\x69\x6e\x67\x20\x75\x73\x65\x72\x20\x77\x68\x65\x74\x68\x65\x72\x20\x68\x65\x20\x77\x61\x6e\x74\x73\x20\x74\x6f"
);if ((not (NXMsg::check_msg (
"\x69\x41\x73\x6b\x55\x73\x65\x72\x57\x72\x6f\x6e\x67\x43\x65\x72\x74",
"\x4e\x58\x53\x75\x64\x6f")))){NXMsg::register_response (
"\x4e\x58\x53\x75\x64\x6f",
"\x69\x41\x73\x6b\x55\x73\x65\x72\x57\x72\x6f\x6e\x67\x43\x65\x72\x74",
(0x14eb+ 2970-0x1d85),
"\x57\x61\x72\x6e\x69\x6e\x67\x2c\x20\x72\x65\x6d\x6f\x74\x65\x20\x68\x6f\x73\x74\x20\x69\x64\x65\x6e\x74\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x20\x68\x61\x73\x20\x63\x68\x61\x6e\x67\x65\x64\x2e\x20\x54\x68\x69\x73\x20\x63\x61\x6e\x20\x69\x6e\x64\x69\x63\x61\x74\x65\x0a\x74\x68\x61\x74\x20\x73\x6f\x6d\x65\x6f\x6e\x65\x20\x69\x73\x20\x74\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x68\x69\x6a\x61\x63\x6b\x20\x74\x68\x65\x20\x6e\x65\x74\x77\x6f\x72\x6b\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2c\x20\x6f\x72\x20\x74\x68\x65\x20\x53\x53\x4c\x0a\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x6f\x6e\x20\x72\x65\x6d\x6f\x74\x65\x20\x73\x65\x72\x76\x65\x72\x20\x68\x61\x76\x65\x20\x62\x65\x65\x6e\x20\x63\x68\x61\x6e\x67\x65\x64\x2e\x0a\x44\x6f\x20\x79\x6f\x75\x20\x77\x61\x6e\x74\x20\x74\x6f\x20\x72\x65\x6d\x6f\x76\x65\x20\x74\x68\x65\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x66\x72\x6f\x6d\x20\x74\x68\x65\x20\x6c\x6f\x63\x61\x6c\x20\x6c\x69\x73\x74\x20\x6f\x66\x20\x6b\x6e\x6f\x77\x6e\x0a\x68\x6f\x73\x74\x73\x3f\x5b\x79\x65\x73\x7c\x6e\x6f\x5d\x3a\x20"
);}NXMsg::send_response (
"\x69\x41\x73\x6b\x55\x73\x65\x72\x57\x72\x6f\x6e\x67\x43\x65\x72\x74",
"\x4e\x58\x53\x75\x64\x6f");Common::NXCore::readInputTillNewline (
main::nxgetSTDIN (),(\$answer));NXNodeExec::sendToNode ($answer);}else{
Logger::error (((
"\x53\x6f\x6d\x65\x74\x68\x69\x6e\x67\x20\x67\x6f\x65\x73\x20\x77\x72\x6f\x6e\x67\x20\x77\x69\x74\x68\x20"
.$msg)."\x2e"));}}sub NXSudo::handleAskUserSetPublicKeyOnRemoteNode{package 
NXSudo;no warnings;(my $msg=shift (@_));main::nxwrite (main::nxgetSTDOUT (),$msg
);if (($msg=~ /NX> $GLOBAL::MSG_ASK_USER_PUBLIC_KEY this key and try again/ )){
Logger::debug (
"\x41\x73\x6b\x69\x6e\x67\x20\x75\x73\x65\x72\x20\x77\x68\x65\x74\x68\x65\x72\x20\x68\x65\x20\x77\x61\x6e\x74\x73\x20\x74\x6f\x20\x61\x64\x64\x20\x6b\x65\x79\x73\x20\x6f\x6e\x20\x72\x65\x6d\x6f\x74\x65\x20\x6e\x6f\x64\x65\x2e"
);my ($answer);Common::NXCore::readInputTillNewline (main::nxgetSTDIN (),(
\$answer));NXNodeExec::sendToNode ($answer);}else{Logger::error ((
"\x53\x6f\x6d\x65\x74\x68\x69\x6e\x67\x20\x67\x6f\x65\x73\x20\x77\x72\x6f\x6e\x67\x20\x77\x69\x74\x68\x20"
.$msg));}}sub NXSudo::handleAskUserRemoteNodeSudoUsername{package NXSudo;no 
warnings;(my $msg=shift (@_));if (($msg=~ /NX> $GLOBAL::MSG_ASK_LOGIN/ )){
Logger::debug (
"\x52\x65\x71\x75\x65\x73\x74\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x6e\x61\x6d\x65\x2e"
);(my $answer=NXMsg::send_request ("\x70\x72\x6f\x70\x65\x72\x74\x79",
"\x4e\x58\x53\x68\x65\x6c\x6c",undef,"\x75\x73\x65\x72\x6e\x61\x6d\x65",
getRemoteNodeHost (),getRemoteNodePort (),"\x6e\x6f\x64\x65\x2d\x73\x75\x64\x6f"
));($answer.="\x0a");(my $passDecoded=Common::NXCore::urlencode ($answer));
Logger::debug (((
"\x55\x73\x65\x72\x6e\x61\x6d\x65\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x75\x73\x65\x72\x20\x69\x6e\x70\x75\x74\x3a\x20\x5b"
.$answer).
"\x5d\x2c\x20\x73\x65\x6e\x64\x69\x6e\x67\x20\x69\x74\x20\x74\x6f\x20\x6e\x6f\x64\x65\x2e"
));NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_TO_SUDO_PROCES).
"\x20").$passDecoded)."\x20"));}}sub NXSudo::handleAskUserRemoteNodeSudoPassword
{package NXSudo;no warnings;(my $msg=shift (@_));if (($msg=~ /NX> $GLOBAL::MSG_ASK_PASSWORD/ )
){Logger::debug (
"\x52\x65\x71\x75\x65\x73\x74\x20\x66\x6f\x72\x20\x70\x61\x73\x73\x77\x6f\x72\x64\x2e"
);(my $answer=NXMsg::send_hrequest ("\x70\x72\x6f\x70\x65\x72\x74\x79",
"\x4e\x58\x53\x68\x65\x6c\x6c","\x70\x61\x73\x73\x77\x6f\x72\x64",
getRemoteNodeHost (),getRemoteNodePort (),"\x6e\x6f\x64\x65\x2d\x73\x75\x64\x6f"
));($answer.="\x0a");(my $passDecoded=Common::NXCore::urlencode ($answer));
Logger::debug (((
"\x50\x61\x73\x73\x77\x6f\x72\x64\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x75\x73\x65\x72\x20\x69\x6e\x70\x75\x74\x3a\x20\x5b"
.$answer).
"\x5d\x2c\x20\x73\x65\x6e\x64\x69\x6e\x67\x20\x69\x74\x20\x74\x6f\x20\x6e\x6f\x64\x65\x2e"
));NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_TO_SUDO_PROCES).
"\x20").$passDecoded)."\x20"));}}sub NXSudo::handleAskUserRemoteNodeSudoPrompt{
package NXSudo;no warnings;(my $msg=shift (@_));if (($msg=~ /NX> $GLOBAL::MSG_SUDO_VERIFICATION/ )
){Logger::debug (
"\x52\x65\x71\x75\x65\x73\x74\x20\x66\x6f\x72\x20\x73\x75\x64\x6f\x20\x70\x61\x73\x73\x77\x6f\x72\x64\x2e"
);(my $answer=NXMsg::send_hrequest ("\x70\x72\x6f\x70\x65\x72\x74\x79",
"\x4e\x58\x53\x68\x65\x6c\x6c","\x70\x61\x73\x73\x77\x6f\x72\x64",
getRemoteNodeHost (),getRemoteNodePort (),"\x6e\x6f\x64\x65\x2d\x73\x75\x64\x6f"
));($answer.="\x0a");(my $passDecoded=Common::NXCore::urlencode ($answer));
Logger::debug (((
"\x50\x61\x73\x73\x77\x6f\x72\x64\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x75\x73\x65\x72\x20\x69\x6e\x70\x75\x74\x3a\x20\x5b"
.$answer).
"\x5d\x2c\x20\x73\x65\x6e\x64\x69\x6e\x67\x20\x69\x74\x20\x74\x6f\x20\x6e\x6f\x64\x65\x2e"
));NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_TO_SUDO_PROCES).
"\x20").$passDecoded)."\x20"));}}sub NXSudo::__saveRemoteNodeCertificate{package
 NXSudo;no warnings;(my $cert=shift (@_));Logger::debug (((
"\x5f\x5f\x73\x61\x76\x65\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x72\x65\x70\x6f\x72\x74\x3a\x5b"
.$cert)."\x5d"));($remoteNodeCertificate=$cert);}sub 
NXSudo::__getRemoteNodeCertificate{package NXSudo;no warnings;Logger::debug (((
"\x5f\x5f\x67\x65\x74\x52\x65\x6d\x6f\x74\x65\x4e\x6f\x64\x65\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x72\x65\x70\x6f\x72\x74\x3a\x5b"
.$remoteNodeCertificate)."\x5d"));return ($remoteNodeCertificate);}sub 
NXSudo::handleMsgSudoOutput{package NXSudo;no warnings;(my $line=shift (@_));
Logger::debug (((
"\x68\x61\x6e\x64\x6c\x65\x4d\x73\x67\x53\x75\x64\x6f\x4f\x75\x74\x70\x75\x74\x20\x72\x65\x63\x69\x76\x65\x64\x3a\x20\x5b"
.$line)."\x5d"));if (($line=~ /NX> 1201 sudo output is: (.*) / )){(my $sudoMsg=
main::urldecode ($1));parseMsgFromSudoCommand ($sudoMsg);}}sub 
NXSudo::parseMsgFromSudoCommand{package NXSudo;no warnings;(my $msg=shift (@_));
Logger::debug (((
"\x70\x61\x72\x73\x65\x4d\x73\x67\x46\x72\x6f\x6d\x53\x75\x64\x6f\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x63\x69\x76\x65\x64\x3a\x20\x5b"
.$msg)."\x5d"));if (($msg=~ /NX> (\d+) / )){loadHandlersArray ();(my $code=$1);
if (($MessagesFromSudoCommand{$code}ne (""))){(my $func=$MessagesFromSudoCommand
{$code});Logger::debug ((((
"\x70\x61\x72\x73\x65\x4d\x73\x67\x46\x72\x6f\x6d\x53\x75\x64\x6f\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x67\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x3a\x20"
.$func).
"\x20\x66\x6f\x72\x20\x68\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x73\x67\x20\x77\x69\x74\x68\x20\x63\x6f\x64\x65\x3a\x20"
).$code));return (&$func ($msg));}else{Logger::debug ((
"\x70\x61\x72\x73\x65\x4d\x73\x67\x46\x72\x6f\x6d\x53\x75\x64\x6f\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x68\x61\x6e\x64\x6c\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x66\x72\x6f\x6d\x20\x6d\x73\x67\x3a\x20"
.$code));}}if ((((($msg=~ /password for/ )or ($msg=~ /Password/ ))or ($msg=~ /'s password/ )
)or ($msg=~ /assword:\ *$/ ))){sudoCommandAskForPassword ();}elsif (($msg=~ /is not in the sudoers file/ )
){(my $error=
"\x55\x73\x65\x72\x20\x69\x73\x20\x6e\x6f\x74\x20\x69\x6e\x20\x73\x75\x64\x6f\x65\x72\x73\x20\x66\x69\x6c\x65\x2e"
);Logger::warning ($error);(my $msg=(((("\x4e\x58\x3e\x20".$GLOBAL::MSG_ERROR).
"\x20\x45\x52\x52\x4f\x52\x3a\x20").$error)."\x0a"));sendToPlayer ($msg);}else{
sendToPlayer ($msg);NXNodeExec::addToCommitedStdout ($msg);}}sub 
NXSudo::setRemoteNodeHost{package NXSudo;no warnings;(my $host=shift (@_));(
$remoteNodeHost=$host);}sub NXSudo::setRemoteNodePort{package NXSudo;no warnings
;(my $port=shift (@_));($remoteNodePort=$port);}sub NXSudo::getRemoteNodeHost{
package NXSudo;no warnings;return ($remoteNodeHost);}sub 
NXSudo::getRemoteNodePort{package NXSudo;no warnings;return ($remoteNodePort);}
sub NXSudo::sendToPlayer{package NXSudo;no warnings;(my $msg=shift (@_));
main::nxwrite (main::nxgetSTDOUT (),$msg);}sub NXSudo::handleMsgSudoFinished{
package NXSudo;no warnings;();}sub NXSudo::sudoCommandAskForPassword{package 
NXSudo;no warnings;(my $adress=NXSessionParameters::getRemoteAdress ());(my $port
=NXSessionParameters::getRemotePort ());(my $answer=NXMsg::send_hrequest (
"\x70\x72\x6f\x70\x65\x72\x74\x79","\x4e\x58\x53\x68\x65\x6c\x6c",
"\x70\x61\x73\x73\x77\x6f\x72\x64",Common::NXInfo::getHostInfo (),
NXAuth::getActiveConnectionPort (),"\x73\x75\x64\x6f"));Logger::debug ((
"\x73\x75\x64\x6f\x43\x6f\x6d\x6d\x61\x6e\x64\x41\x73\x6b\x46\x6f\x72\x50\x61\x73\x73\x77\x6f\x72\x64\x20\x67\x65\x74\x20"
.$answer));($answer.="\x0a");(my $passDecoded=Common::NXCore::urlencode ($answer
));NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_TO_SUDO_PROCES).
"\x20").$passDecoded)."\x20"));}package NXSudo;no warnings;
NXMsg::register_request ("\x4e\x58\x53\x75\x64\x6f",
"\x63\x6f\x6e\x66\x69\x72\x6d\x43\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65",
(0x1162+ 3429-0x1dcd),
"\x63\x6f\x6e\x66\x69\x72\x6d\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x64\x20\x66\x6f\x72\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x66\x69\x6e\x67\x65\x72\x70\x72\x69\x6e\x74\x20\x25\x73"
,"\x5e\x2e\x2a\x24");"\x3f\x3f\x3f";
